<?php

App::uses('AppShell', 'Console/Command');

App::uses('ComponentCollection', 'Controller');
App::uses('ProductsComponent', 'EvShop.Controller/Component');

App::uses('RouterUtil', 'Routable.Lib');
App::uses('GoogleFeedLib', 'EvShop.Lib');

class GenerateProductFeedXMLShell extends AppShell {

	public function generate() {
		ini_set('memory_limit', '256M');

		$xmlPath = 'webroot/product_feed.xml';
		if (!empty(Configure::read('EvShop.googleFeedFilepath'))) {
			$xmlPath = Configure::read('EvShop.googleFeedFilepath');
		}

		$this->out('Generating Product Feed...');

		$output = $this->_generateFeed();

		$result = file_put_contents(APP . $xmlPath, $output);

		if ($result !== false) {
			$this->out('Success :) File located @ ' . $xmlPath);
		} else {
			$this->out('Failed to save feed at ' . $xmlPath);
		}
	}

	/**
	 * Override this to generate the feedd in a different way
	 */
	protected function _generateFeed() {
		$feedLib = new GoogleFeedLib();
		return $feedLib->generate();
	}
}
